//need black, grey, and while flags.

/*
 * CycleDetector.java
 *
 * Created on 2006~52, U 7:54
 */

/**
 *
 * @author ythuang
 */

import java.util.*;
public class CycleRemover {
    
    Hashtable graph;
    Hashtable color;
    
    int count = 0;
    /** Creates a new instance of CycleDetector */
    public CycleRemover(Hashtable graph) {
        this.graph = (Hashtable) graph.clone();
        this.color = new Hashtable();
    }
    
    //detect cycle in the graph which might be forest
    //return a solution without cycle
    public Hashtable removeCycle(){
        Enumeration et = this.graph.keys();
        while(et.hasMoreElements()){
            String node = (String) et.nextElement();
            if(!this.color.containsKey(node))
                DFS(node);
        }
        return this.graph;
    }
    
    private void DFS(String node){
	System.out.println(node);
        this.color.put(node, "g");    //set gray
        Vector childnodes = (Vector) this.graph.get(node);
        
        if(childnodes.size()>1){    //1 means no children
            for(int i=0; i<childnodes.size(); i++){
                String temp = (String) childnodes.elementAt(i);
                if(!this.color.containsKey(temp)){
                        //if this child node is not visited yet
                        DFS(temp);
                }else{
                    String type= (String) this.color.get(temp);
                    if(type.equals("g")){
                        //a back edge
                        //detect a cycle, remove the edges adjacent to this node
                        Vector selfvec = new Vector();
                        selfvec.add(temp);
                        this.graph.put(temp, selfvec);
                        this.color.put(temp,  ""); //set black and finish
                    }
                 }
                 
                 //check if this node was removed in recursive DFS
                 Vector tempvec = (Vector) this.graph.get(node);
                 if(tempvec.size() == 1){
                    //this node was removed, no need to check it's other child nodes, break the loop
			this.count++;
                  break;
                 }
            }//end of for loop
        }//end of if having child
        
        this.color.put(node,  ""); //set black and finish
    }
    
    public int getCount(){
        return this.count;
    }
    
    public static void main(String[] args){
        Hashtable ht = new Hashtable();
        Vector v1 = new Vector();
        String one = "1";
        String two = "2";
        String three = "3";
        String four = "4";
        
        v1.add(two);
        v1.add(three);
        ht.put(one, v1);
        Vector v2 = new Vector();
        v2.add(one);
        v2.add(four);
        ht.put(two, v2);
        Vector v3 = new Vector();
        v3.add(one);
        v3.add(two);
        ht.put(three, v3);
        Vector v4 = new Vector();
        v4.add(four);
        v4.add(two);
        ht.put(four, v4);
        
        CycleRemover cd = new CycleRemover(ht);
        System.out.println(cd.removeCycle());
    }
}
