/*
 * HapTagger.java
 *
 * Created on 2006~51, U 3:35
 */

/**
 *
 * @author ythuang
 */
import java.io.*;
import java.util.*;

public class HapTagger{
	public HapTagger(String name){
            int NumOfSNP=0;
            try{
			//Parsing input file
			BufferedReader br = new BufferedReader(new FileReader(name));
                  //BufferedWriter bw = new BufferedWriter(new FileWriter(name+".out"));
			System.out.println("Start processing: "+name);
        		
                  //read haplotype into a vector with stringbuffer
        		String temp = br.readLine();
                  Vector hap = new Vector();
                  while(temp != null){
                  	StringTokenizer st = new StringTokenizer(temp);
                  	StringBuffer sb = new StringBuffer("");
                  	while(st.hasMoreTokens()){
                  	    sb.append(st.nextToken());
                  	}
                  	
                  	hap.add(sb);
                  	NumOfSNP = sb.length();
                  	temp=br.readLine();
                  }
                  
                  //System.out.println(hap);
                  //adjust major allele to 0 and minor to 1
                  for(int i=0; i<NumOfSNP; i++){
                  	int majorcount =0, minorcount=0;
				for(int j=0; j<hap.size(); j++){
					StringBuffer sb = (StringBuffer) hap.elementAt(j);
					if(sb.charAt(i) == '0')
						majorcount++;
					else
						minorcount++;
				}
				if(minorcount > majorcount){
					for(int j=0; j<hap.size(); j++){
						StringBuffer sb = (StringBuffer) hap.elementAt(j);
						if(sb.charAt(i) == '0')
							sb.setCharAt(i, '1');
						else
							sb.setCharAt(i, '0');
					}
				}
                  }
                  
                  Vector InitSet = new Vector(NumOfSNP);
                  for(int i=0; i<NumOfSNP; i++){
                      InitSet.add(new Integer(i));
                  }
                  
                  Vector SetContainer = new Vector();
                  SetContainer.add(InitSet);
                  Vector LDBins = new Vector();
                  
                  //group perfect LD bins
                  for(int i=0; i<hap.size(); i++){
                      StringBuffer sb = (StringBuffer) hap.elementAt(i);
                      for(int j=0; j<SetContainer.size(); j++){
                          Vector set = (Vector) SetContainer.elementAt(j);
                          
                          //for each element in Vector
                          Vector set1=new Vector();
                          Vector set2=new Vector();
                          for(int k=0; k<set.size(); k++){
                              Integer index = (Integer) set.elementAt(k);
                              if(sb.charAt(index.intValue()) == '0'){
                                  set1.add(index);
                              }
                              else if(sb.charAt(index.intValue()) == '1'){
                                  set2.add(index);
                              }else{
                                  System.out.println("Missing data");
                              }
                          }

                          if(!set1.isEmpty())
                              LDBins.add(set1);
                          if(!set2.isEmpty())
                              LDBins.add(set2);
                      }
                      
                      SetContainer = (Vector)LDBins.clone();
                      LDBins.clear();
                  }//end of for
                  
                  //Force garbage collection
                  System.gc();
                  
                  //Extract Tag SNPs
                  Vector SNPs = new Vector();
                  Hashtable SNPIndex = new Hashtable();
                  for(int i=0; i<SetContainer.size(); i++){
                        StringBuffer line = new StringBuffer();
                        Vector onebin = (Vector)SetContainer.elementAt(i);

                        int index = ((Integer)onebin.elementAt(0)).intValue();
                  	for(int j=0; j<hap.size();j++){
                            StringBuffer haplotype = (StringBuffer)hap.elementAt(j);
                            line.append(haplotype.charAt(index));
                  	}
                        SNPs.add(line);
                        SNPIndex.put(line.toString(), new Integer(index));
                  }
                  
                  //System.out.println("Tag SNPs: "+SNPs);
                  //run greedy algorithm to replace each tag SNP
                  Hashtable solution = new Hashtable();
                  int tagSNPcount = 0;
                  for(int i=0; i<SNPs.size();i++){
                      StringBuffer target = (StringBuffer)SNPs.elementAt(i);
                      Vector tempvec = (Vector)SNPs.clone();
                      tempvec.remove(i);
                      MHTagger MHT = new MHTagger(tempvec,target);
                      //System.out.println("Solution: "+MHT.execute());
                      Vector vv = (Vector) MHT.execute();
                      solution.put(target.toString(), vv);  
                      if(vv.size() == 1)
                          tagSNPcount++;
                      //solution.add(MHT.execute());
                  }
 
                  //write solution into a file
                  BufferedWriter bw = new BufferedWriter(new FileWriter(name+".out"));
                    
                  System.out.println("Number of Tag SNPs b4 removal: "+tagSNPcount);
                  //System.out.println(solution);
                  bw.write("Number of Tag SNPs b4 removal: "+tagSNPcount);
                  bw.newLine();
                  //remove cycle
                  //CycleDetector cd = new CycleDetector(solution);
                  CycleRemover cd = new CycleRemover(solution);
                  solution = cd.removeCycle();
                  
                  System.out.println("Number of Tag SNPs removal: "+cd.getCount());
                  tagSNPcount = tagSNPcount + cd.getCount();
                  //System.out.println(solution);
                  
                  bw.write("Total tag SNPs number: "+tagSNPcount);
                  bw.newLine();
                  
                  tagSNPcount = 0;
                  Enumeration et = solution.elements();
                    while(et.hasMoreElements()){
                        Vector node = (Vector) et.nextElement();
                        if(node.size()==1)
                            tagSNPcount++;
                    }
                    System.out.println("Total tag SNPs number: "+tagSNPcount);
                  
                  for(int i=0; i<NumOfSNP; i++){
                      bw.write("SNP"+(i+1));
                      
                      StringBuffer line = new StringBuffer();
                      for(int j=0; j<hap.size(); j++){
                            StringBuffer haplotype = (StringBuffer)hap.elementAt(j);
                            line.append(haplotype.charAt(i));
                      }
                      
                      Vector tagresult = (Vector) solution.get(line.toString());
                      for(int j=0; j<tagresult.size(); j++){
                          int index = ((Integer) SNPIndex.get(tagresult.elementAt(j))).intValue();
                          bw.write("\t"+(index+1));
                      }
                      bw.newLine();
                  }
                 
                  bw.flush();
                  bw.close();
                   
            }
            catch(IOException e){
                e.printStackTrace();
            }
       }
	
	public static void main(String[] args){
		new HapTagger(args[0]);
	}
}